/*compilation : gcc psilin-0.9.c -o psilin `gtk-config --cflags --libs` */
/*necessite gkt - test avec gtk 1.2*/
/*Free Software license GPL*/
/*Copie et modifications encourages*/
/* Gerard Delafond */
/* petite aide de Charles Vidal et Christophe Merlet */
/*La copie marche. Bizarreries des transferts PC>Psion dues  p3nfs*/
/*La conversion S5 plante sur de nombreux fichers. Ne pas hsiter  mette  jour Psiconv (0.5 actuellement)*/
/*La conversion agenda plante sur certains fichers*/

#define ENABLE_NLS 1
#define PACKAGE "psilin"
#define GNOMELOCALEDIR "/usr/share/locale"

#ifdef ENABLE_NLS
#  include <locale.h>
#  include <libintl.h>
#  define _(String) gettext (String)
#  ifdef gettext_noop
#    define N_(String) gettext_noop (String)
#  else
#    define N_(String) (String)
#  endif
#else
/* Stubs that do something close enough. */
#  define textdomain(String) (String)
#  define gettext(String) (String)
#  define dgettext(Domain,Message) (Message)
#  define dcgettext(Domain,Message,Type) (Message)
#  define bindtextdomain(Domain,Directory) (Domain)
#  define _(String) (String)
#  define N_(String) (String)
#endif

#include <gtk/gtk.h>
#include <unistd.h>
#define STRINGSIZE 512
#define VERSION _("PsiLin \n\nGerard Delafond and Charles Vidal V 0.9")

GtkWidget *filew, *filew_source, *filew_cible;
// default values - change them as you like
gchar *dir = "/psion.stand/";
gchar *tty = "ttyS0";
gchar *serie5 = "";
gchar *modele = "Series 3c";
gchar *vitesse = "57600";
gchar *format = "none";
gchar *disque_psion = "i";
gchar *fich_source;
gchar *fich_cible;
gchar *param_sup = "";

/* Code get from gtksamba thank's to the author */

void
make_error_mesg (char *message1, char *message2)
{
  GtkWidget *diag;
  GtkWidget *label;
  GtkWidget *button;

  diag = gtk_dialog_new ();

  gtk_signal_connect_object (GTK_OBJECT (diag), "delete_event",
			     GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     GTK_OBJECT (diag));
  gtk_window_set_title (GTK_WINDOW (diag), "Infos");
  gtk_window_position (GTK_WINDOW (diag), GTK_WIN_POS_CENTER);

  if (message1)
    {
      label = gtk_label_new (message1);
      gtk_box_pack_start (GTK_BOX (GTK_DIALOG (diag)->vbox),
			  label, TRUE, TRUE, 0);
      gtk_widget_show (label);
    }

  if (message2)
    {
      label = gtk_label_new (message2);
      gtk_box_pack_start (GTK_BOX (GTK_DIALOG (diag)->vbox),
			  label, TRUE, TRUE, 0);
      gtk_widget_show (label);
    }

  button = gtk_button_new_with_label ("OK");
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (diag)->action_area),
		      button, TRUE, TRUE, 0);
  gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
			     GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     GTK_OBJECT (diag));
  gtk_widget_show (button);

  gtk_widget_show (diag);

  return;

}

gint
sw_delete_event (GtkWidget * widget, GdkEvent * event, gpointer data)
{
  return TRUE;
}

void
a_propos (GtkWidget * widget, gpointer data)
{
  make_error_mesg (VERSION, "  \n  http://www.medsyn.fr/perso/g.delafond");
}

void
rappel_bouton_tty (GtkWidget * widget, gpointer data)
{
  if (GTK_TOGGLE_BUTTON (widget)->active)
    tty = (gchar *) data;
}

void
rappel_bouton_commutateur (GtkWidget * widget, gpointer data)
{
  if (GTK_TOGGLE_BUTTON (widget)->active)
    modele = (gchar *) data;
}

void
rappel_bouton_disque (GtkWidget * widget, gpointer data)
{
  if (GTK_TOGGLE_BUTTON (widget)->active)
    disque_psion = (gchar *) data;
}

void
rappel_bouton_format (GtkWidget * widget, gpointer data)
{
  if (GTK_TOGGLE_BUTTON (widget)->active)
    format = (gchar *) data;
}

void
connecte (GtkWidget * widget, gpointer data)
{
  char command[STRINGSIZE];
  if (modele == "Series 3")
    {
      vitesse = "9600";
      serie5 = "";
    }
  else if (modele == "Series 3a-Siena")
    {
      vitesse = "19200";
      serie5 = "";
    }
  else if (modele == "Series 3c")
    {
      vitesse = "57600";
      serie5 = "";
    }
  else if (modele == "Series 3 mx")
    {
      vitesse = "115200";
      serie5 = "";
    }
  else if (modele == "Series 5")
    {
      vitesse = "115200";
      serie5 = "-oldnfsc -series5";
    }
  sprintf (command,
	   "p3nfsd -dir %smnt -user $USER -speed %s -tty /dev/%s %s -shell $SHELL\n",
	   dir, vitesse, tty, serie5);
  system (command);
}

void
deconnect (GtkWidget * widget, gpointer * data)
{
  char command[STRINGSIZE];
  sprintf (command, "ls %smnt/exit\n", dir);
  system (command);
}

void
transferts (GtkWidget * widget, gpointer * data)
{
  char copie[STRINGSIZE];
  if (format == "none")
    {
      sprintf (copie, "cp %s %s", fich_source, fich_cible);
      system (copie);
    }
  else if (format == "lpic2ps")
    {
      sprintf (copie, "%s %s %s", format, fich_source, fich_cible);
      system (copie);
    }
  else if (format == "sox")
    {
      sprintf (copie, "%s %s %s", format, fich_source, fich_cible);
      system (copie);
    }
  else if (format == "nconvert")
    {
      sprintf (copie, "/usr/X11R6/bin/%s -out bmp %s", format, fich_source);
      system (copie);
    }
  else if (format == "tsv2dbf")
    {
      sprintf (copie, "tsv2dbf -r -c <%s > %s", fich_source, fich_cible);
      system (copie);
    }
  else if (format == "tsv2spr")
    {
      sprintf (copie, "tsv2spr <%s > %s", fich_source, fich_cible);
      system (copie);
    }
  else if (format == "Psiconv")
    {
      sprintf (copie, "psiconv %s -o %s", fich_source, fich_cible);
      system (copie);
    }
  else
    {
      sprintf (copie, "%s %s >> %s", format, fich_source, fich_cible);
      system (copie);
    }
}

void
delete_fichier (GtkWidget * widget, GdkEvent * event, gpointer data)
{
/*gtk_main_quit ();*/
}

void
delete_event (GtkWidget * widget, GdkEvent * event, gpointer data)
{
//c_make_exit_dialog () 
  gtk_main_quit ();
}

void
file_ok_sel (GtkWidget * w, GtkFileSelection * fs)
{
  dir = (gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs)));
  gtk_widget_hide (filew);
}

void
file_source_sel (GtkWidget * w, GtkFileSelection * fs)
{
  fich_source = (gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs)));
  gtk_widget_hide (filew_source);
}

void
file_cible_sel (GtkWidget * w, GtkFileSelection * fs)
{
  fich_cible = (gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs)));
  gtk_widget_hide (filew_cible);
}

void
selec_rep (GtkWidget * w, GtkFileSelection * fs)
{
//filew = gtk_file_selection_new ("Slection du rpertoire de montage");
  filew = gtk_file_selection_new (_("Select the mounting directory"));
  gtk_signal_connect (GTK_OBJECT (filew), "destroy",
		      (GtkSignalFunc) delete_fichier, &filew);
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button),
		      "clicked", (GtkSignalFunc) file_ok_sel, filew);
  gtk_signal_connect_object (GTK_OBJECT
			     (GTK_FILE_SELECTION (filew)->cancel_button),
			     "clicked", (GtkSignalFunc) gtk_widget_destroy,
			     GTK_OBJECT (filew));
  gtk_file_selection_set_filename (GTK_FILE_SELECTION (filew), ("%s", dir));
  gtk_widget_show (filew);
}

void
selec_source (GtkWidget * w, GtkFileSelection * fs)
{
//filew_source = gtk_file_selection_new ("Slection du fichier source pour un transfert");
  filew_source =
    gtk_file_selection_new (_("Select the source file for a transfer"));
  gtk_signal_connect (GTK_OBJECT (filew_source), "destroy",
		      (GtkSignalFunc) delete_fichier, &filew_source);
  gtk_signal_connect (GTK_OBJECT
		      (GTK_FILE_SELECTION (filew_source)->ok_button),
		      "clicked", (GtkSignalFunc) file_source_sel,
		      filew_source);
  gtk_signal_connect_object (GTK_OBJECT
			     (GTK_FILE_SELECTION (filew_source)->
			      cancel_button), "clicked",
			     (GtkSignalFunc) gtk_widget_destroy,
			     GTK_OBJECT (filew_source));
  gtk_file_selection_set_filename (GTK_FILE_SELECTION (filew_source), "/");
  gtk_widget_show (filew_source);
}

void
selec_cible (GtkWidget * w, GtkFileSelection * fs)
{
//filew_cible = gtk_file_selection_new ("Slection du rpertoire cible pour le transfert");
  filew_cible =
    gtk_file_selection_new (_
			    ("Select the targer directory for the transfer"));
  gtk_signal_connect (GTK_OBJECT (filew_cible), "destroy",
		      (GtkSignalFunc) delete_fichier, &filew_cible);
  gtk_signal_connect (GTK_OBJECT
		      (GTK_FILE_SELECTION (filew_cible)->ok_button),
		      "clicked", (GtkSignalFunc) file_cible_sel, filew_cible);
  gtk_signal_connect_object (GTK_OBJECT
			     (GTK_FILE_SELECTION (filew_cible)->
			      cancel_button), "clicked",
			     (GtkSignalFunc) gtk_widget_destroy,
			     GTK_OBJECT (filew_cible));
  gtk_file_selection_set_filename (GTK_FILE_SELECTION (filew_cible), "/");
  gtk_widget_show (filew_cible);
}

void
backup (GtkWidget * widget, gpointer * data)
{
  char command[STRINGSIZE];
  sprintf (command,
	   "perl -w /usr/bin/PsiBackup.pl -mount %s/mnt -backup %s -disk %s",
	   dir, fich_cible, disque_psion);
  system (command);
}

int
main (int argc, char *argv[])
{
  GtkWidget *window;
  GtkWidget *button_about;
  GtkWidget *button_quitte, *button_connect, *button_deconnect,
    *button_disque;
  GtkWidget *table;
  GtkWidget *label_reglages, *label_serie, *label_modele, *label_rep;
  GtkWidget *button_serie, *button_modele, *button_rep;
  GSList *groupe_serie, *groupe_modele, *groupe_disque;
  GtkWidget *label_conversion, *label_transfert, *button_source,
    *button_cible;
  GtkWidget *button_format, *button_copier, *button_sup;
  GSList *groupe_format;
  GtkWidget *button_sauvegarde;
  GtkTooltips *gtooltip;
  gchar *com;

  gtk_set_locale();
  bindtextdomain (PACKAGE, GNOMELOCALEDIR),
  textdomain (PACKAGE);

  gtk_init (&argc, &argv);

  gtooltip = gtk_tooltips_new ();

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);

  gtk_window_set_title (GTK_WINDOW (window), "PsiLin");

  gtk_signal_connect (GTK_OBJECT (window), "delete_event",
		      GTK_SIGNAL_FUNC (delete_event), NULL);

  gtk_container_border_width (GTK_CONTAINER (window), 20);

  table = gtk_table_new (18, 3, TRUE);
  gtk_container_add (GTK_CONTAINER (window), table);

//button_about = gtk_button_new_with_label ("A propos");
  button_about = gtk_button_new_with_label (_("About"));
  gtk_table_attach_defaults (GTK_TABLE (table), button_about, 0, 3, 0, 1);
  gtk_signal_connect (GTK_OBJECT (button_about), "clicked",
		      GTK_SIGNAL_FUNC (a_propos), (gpointer) "a Propos");
  gtk_widget_show (button_about);
//gtk_tooltips_set_tip (gtooltip, button_about, "Psilin Version 0.9\nG.DELAFOND & C.VIDAL\nhttp://www.medsyn.fr/perso/g.delafond\nCe programme ncessite p3nfs pour les connexions, psionio pour les conversions s3, Psiconv pour les conversions s5 et Psibackup pour les sauvegardes s3",NULL);
  gtk_tooltips_set_tip (gtooltip, button_about,
			_
			("Psilin Version 0.9\nG.DELAFOND & C.VIDAL\nhttp://delafond.org/psilin\nThis program needs p3nfs for the connections, psionio, Xnview, sox and lpic2ps for S3 conversions, Psiconv for S5 conversions and Psibackup for S3 backups"),
			NULL);

//label_reglages = gtk_label_new("Paramtres de connexion");
  label_reglages = gtk_label_new (_("Connection parameters"));
  gtk_table_attach_defaults (GTK_TABLE (table), label_reglages, 0, 3, 1, 2);
  gtk_widget_show (label_reglages);

//label_serie = gtk_label_new("Port srie");
  label_serie = gtk_label_new (_("Serial Port"));
  gtk_table_attach_defaults (GTK_TABLE (table), label_serie, 0, 1, 2, 3);
  gtk_widget_show (label_serie);

//label_modele = gtk_label_new("Modle");
  label_modele = gtk_label_new (_("Model"));
  gtk_table_attach_defaults (GTK_TABLE (table), label_modele, 1, 2, 2, 3);
  gtk_widget_show (label_modele);

  label_rep = gtk_label_new (_("Directory"));
  gtk_table_attach_defaults (GTK_TABLE (table), label_rep, 2, 3, 2, 3);
  gtk_widget_show (label_rep);

  button_serie = gtk_radio_button_new_with_label (NULL, "ttyS0");
  gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (button_serie), TRUE);
  gtk_table_attach_defaults (GTK_TABLE (table), button_serie, 0, 1, 3, 4);
  gtk_widget_show (button_serie);
  gtk_signal_connect (GTK_OBJECT (button_serie), "toggled",
		      GTK_SIGNAL_FUNC (rappel_bouton_tty), "ttyS0");
  gtk_tooltips_set_tip (gtooltip, button_serie, "Com 1", NULL);

  groupe_serie = gtk_radio_button_group (GTK_RADIO_BUTTON (button_serie));
  button_serie = gtk_radio_button_new_with_label (groupe_serie, "ttyS1");
  gtk_table_attach_defaults (GTK_TABLE (table), button_serie, 0, 1, 4, 5);
  gtk_widget_show (button_serie);
  gtk_signal_connect (GTK_OBJECT (button_serie), "toggled",
		      GTK_SIGNAL_FUNC (rappel_bouton_tty), "ttyS1");
  gtk_tooltips_set_tip (gtooltip, button_serie, "Com 2", NULL);

  groupe_serie = gtk_radio_button_group (GTK_RADIO_BUTTON (button_serie));
  button_serie = gtk_radio_button_new_with_label (groupe_serie, "ttyS2");
  gtk_table_attach_defaults (GTK_TABLE (table), button_serie, 0, 1, 5, 6);
  gtk_signal_connect (GTK_OBJECT (button_serie), "toggled",
		      GTK_SIGNAL_FUNC (rappel_bouton_tty), "ttyS2");
  gtk_widget_show (button_serie);
  gtk_tooltips_set_tip (gtooltip, button_serie, "Com 3", NULL);

  groupe_serie = gtk_radio_button_group (GTK_RADIO_BUTTON (button_serie));
  button_serie = gtk_radio_button_new_with_label (groupe_serie, "ttyS3");
  gtk_table_attach_defaults (GTK_TABLE (table), button_serie, 0, 1, 6, 7);
  gtk_signal_connect (GTK_OBJECT (button_serie), "toggled",
		      GTK_SIGNAL_FUNC (rappel_bouton_tty), "ttyS3");
  gtk_widget_show (button_serie);
  gtk_tooltips_set_tip (gtooltip, button_serie, "Com 4", NULL);

  button_modele = gtk_radio_button_new_with_label (NULL, "Series 3");
  gtk_table_attach_defaults (GTK_TABLE (table), button_modele, 1, 2, 3, 4);
  gtk_widget_show (button_modele);
  gtk_signal_connect (GTK_OBJECT (button_modele), "toggled",
		      GTK_SIGNAL_FUNC (rappel_bouton_commutateur), "Series 3");
//gtk_tooltips_set_tip (gtooltip, button_modele, "Vitesse 9600",NULL);
  gtk_tooltips_set_tip (gtooltip, button_modele, _("Speed 9600"), NULL);


  groupe_modele = gtk_radio_button_group (GTK_RADIO_BUTTON (button_modele));
  button_modele =
    gtk_radio_button_new_with_label (groupe_modele, "Series 3a-Siena");
  gtk_table_attach_defaults (GTK_TABLE (table), button_modele, 1, 2, 4, 5);
  gtk_widget_show (button_modele);
  gtk_signal_connect (GTK_OBJECT (button_modele), "toggled",
		      GTK_SIGNAL_FUNC (rappel_bouton_commutateur),
		      "Series 3a");
//gtk_tooltips_set_tip (gtooltip, button_modele, "Vitesse 19200",NULL);
  gtk_tooltips_set_tip (gtooltip, button_modele, _("Speed 19200"), NULL);
  groupe_modele = gtk_radio_button_group (GTK_RADIO_BUTTON (button_modele));
  button_modele = gtk_radio_button_new_with_label (groupe_modele, "Series 3c");
  gtk_table_attach_defaults (GTK_TABLE (table), button_modele, 1, 2, 5, 6);
  gtk_signal_connect (GTK_OBJECT (button_modele), "toggled",
		      GTK_SIGNAL_FUNC (rappel_bouton_commutateur),
		      "Series 3c-Siena");
  gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (button_modele), TRUE);
  gtk_widget_show (button_modele);
//gtk_tooltips_set_tip (gtooltip, button_modele, "Vitesse 57600",NULL);
  gtk_tooltips_set_tip (gtooltip, button_modele, _("Speed 57600"), NULL);

  groupe_modele = gtk_radio_button_group (GTK_RADIO_BUTTON (button_modele));
  button_modele =
    gtk_radio_button_new_with_label (groupe_modele, "Series 3 mx");
  gtk_table_attach_defaults (GTK_TABLE (table), button_modele, 1, 2, 6, 7);
  gtk_signal_connect (GTK_OBJECT (button_modele), "toggled",
		      GTK_SIGNAL_FUNC (rappel_bouton_commutateur),
		      "Series 3 mx");
  gtk_widget_show (button_modele);
//gtk_tooltips_set_tip (gtooltip, button_modele, "Vitesse 115200",NULL);
  gtk_tooltips_set_tip (gtooltip, button_modele, _("Speed 115200"), NULL);

  groupe_modele = gtk_radio_button_group (GTK_RADIO_BUTTON (button_modele));
  button_modele = gtk_radio_button_new_with_label (groupe_modele, "Series 5");
  gtk_signal_connect (GTK_OBJECT (button_modele), "toggled",
		      GTK_SIGNAL_FUNC (rappel_bouton_commutateur), "Serie 5");
  gtk_table_attach_defaults (GTK_TABLE (table), button_modele, 1, 2, 7, 8);
  gtk_widget_show (button_modele);
//gtk_tooltips_set_tip (gtooltip, button_modele, "Vitesse 115200",NULL);
  gtk_tooltips_set_tip (gtooltip, button_modele, _("Speed 115200"), NULL);

  button_rep = gtk_button_new_with_label (_("Mounting"));
  gtk_table_attach_defaults (GTK_TABLE (table), button_rep, 2, 3, 3, 4);
  gtk_signal_connect (GTK_OBJECT (button_rep), "clicked",
		      GTK_SIGNAL_FUNC (selec_rep), (gpointer) "Rpertoire");
  gtk_widget_show (button_rep);
//gtk_tooltips_set_tip (gtooltip, button_rep, "Choisissez ici votre rpertoire de montage\nVous pouvez monter plusieurs Psions connects sur des prises diffrentes  condition que leur rpertoire de montage soit diffrent\nNe choisissez que des rpertoires contenant des liens vers le psion (voir doc de p3nfs)!!!",NULL);
  gtk_tooltips_set_tip (gtooltip, button_rep,
			_
			("Choose here your mounting directory\nYou can mount several Psions if connected on different sockets and if the mounting diectories are different\nChoose only directories containing links to the Psion (see p3nfs doc)!!!"),
			NULL);

//button_connect = gtk_button_new_with_label ("Connecter");
  button_connect = gtk_button_new_with_label (_("Connect"));
  gtk_signal_connect (GTK_OBJECT (button_connect), "clicked",
		      GTK_SIGNAL_FUNC (connecte), (gpointer) NULL);
  gtk_table_attach_defaults (GTK_TABLE (table), button_connect, 0, 1, 8, 9);
  gtk_widget_show (button_connect);
//gtk_tooltips_set_tip (gtooltip, button_connect, "Connectez physiquement le Psion\nQuittez toutes les applications sur le Psion\nLancez ensuite l'application nfsc sur le Psion\nChoisisez la vitesse maxi pour votre modle\nChoisissez un rpertoire de mountage correctement configur +++\nCliquez ensuite seulement sur ce bouton\nIl est normal que le programme ne ragisse pas pendant quelques secondes",NULL);
  gtk_tooltips_set_tip (gtooltip, button_connect,
			_
			("Connect physically le Psion first\nQuit all the applications on the Psion\nLaunch nfsc on the Psion\nChoose the maximum speed on your Psion\nChoose a correctly configured mounting directory +++\nClic next on this button\nNormally, the program will suspend a few seconds"),
			NULL);

//button_deconnect = gtk_button_new_with_label ("Dconnecter");
  button_deconnect = gtk_button_new_with_label (_("Disconnect"));
  gtk_signal_connect (GTK_OBJECT (button_deconnect), "clicked",
		      GTK_SIGNAL_FUNC (deconnect), (gpointer) NULL);
  gtk_table_attach_defaults (GTK_TABLE (table), button_deconnect, 2, 3, 8, 9);
  gtk_widget_show (button_deconnect);
//gtk_tooltips_set_tip (gtooltip, button_deconnect, "Pour dconnecter le Psion\nA utiliser avec le mme rglage de rpertoire que la connexion\nA utiliser mme si la connexion a chou",NULL);
  gtk_tooltips_set_tip (gtooltip, button_deconnect,
			_
			("To disconnect the Psion\nTo be used with the same directory settings as the connexion\nTo be used even if the connexion failed"),
			NULL);

//label_conversion = gtk_label_new("Conversions");
  label_conversion = gtk_label_new (_("Conversions"));
  gtk_table_attach_defaults (GTK_TABLE (table), label_conversion, 0, 2, 9,
			     10);
  gtk_widget_show (label_conversion);

//button_format = gtk_radio_button_new_with_label (NULL, "Aucune");
  button_format = gtk_radio_button_new_with_label (NULL, _("None"));
  gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (button_format), TRUE);
  gtk_table_attach_defaults (GTK_TABLE (table), button_format, 0, 1, 10, 11);
  gtk_widget_show (button_format);
  gtk_signal_connect (GTK_OBJECT (button_format), "toggled",
		      GTK_SIGNAL_FUNC (rappel_bouton_format), "none");
//gtk_tooltips_set_tip (gtooltip, button_format, "Pour les copies simples sans conversion",NULL);
  gtk_tooltips_set_tip (gtooltip, button_format,
			_("To be used for the transfers with no conversion"),
			NULL);

  groupe_format = gtk_radio_button_group (GTK_RADIO_BUTTON (button_format));
  button_format =
    gtk_radio_button_new_with_label (groupe_format, "wrd > html (S3)");
  gtk_table_attach_defaults (GTK_TABLE (table), button_format, 0, 1, 11, 12);
  gtk_widget_show (button_format);
  gtk_signal_connect (GTK_OBJECT (button_format), "toggled",
		      GTK_SIGNAL_FUNC (rappel_bouton_format), "wrd2html -h");
//gtk_tooltips_set_tip (gtooltip, button_format, "Pour les conversions texte psion3 > texte html",NULL);
  gtk_tooltips_set_tip (gtooltip, button_format,
			_("For the conversions Psion3 text > html text"),
			NULL);

  groupe_format = gtk_radio_button_group (GTK_RADIO_BUTTON (button_format));
  button_format =
    gtk_radio_button_new_with_label (groupe_format, "wrd > txt (S3)");
  gtk_table_attach_defaults (GTK_TABLE (table), button_format, 0, 1, 12, 13);
  gtk_widget_show (button_format);
  gtk_signal_connect (GTK_OBJECT (button_format), "toggled",
		      GTK_SIGNAL_FUNC (rappel_bouton_format), "wrd2html -t");
//gtk_tooltips_set_tip (gtooltip, button_format, "Pour les conversions texte psion3 > texte brut",NULL);
  gtk_tooltips_set_tip (gtooltip, button_format,
			_
			("To be used for the Psion3 and more and Siena text conversions > ASCII text"),
			NULL);
  groupe_format = gtk_radio_button_group (GTK_RADIO_BUTTON (button_format));
  button_format =
    gtk_radio_button_new_with_label (groupe_format, "agn > tsv (S3)");
  gtk_table_attach_defaults (GTK_TABLE (table), button_format, 0, 1, 13, 14);
  gtk_widget_show (button_format);
  gtk_signal_connect (GTK_OBJECT (button_format), "toggled",
		      GTK_SIGNAL_FUNC (rappel_bouton_format),
		      "agn2tsv -a -s");
//gtk_tooltips_set_tip (gtooltip, button_format, "Pour les conversions agenda psion3a et + > texte brut\nAttention ! Plante sur certains types d'entre rpte.\nDans ce cas, faire un kill de agn2tsv",NULL);
  gtk_tooltips_set_tip (gtooltip, button_format,
			_
			("For the Psion3a and more and Siena schedule conversions > ASCII text\nCareful ! Crashes on some repeated entries.\nIn this case, kill agn2tsv"),
			NULL);

  groupe_format = gtk_radio_button_group (GTK_RADIO_BUTTON (button_format));
  button_format =
    gtk_radio_button_new_with_label (groupe_format, "memo > tsv (S3)");
  gtk_table_attach_defaults (GTK_TABLE (table), button_format, 0, 1, 14, 15);
  gtk_widget_show (button_format);
  gtk_signal_connect (GTK_OBJECT (button_format), "toggled",
		      GTK_SIGNAL_FUNC (rappel_bouton_format),
		      "agn2tsv -a -m");
//gtk_tooltips_set_tip (gtooltip, button_format, "Pour les conversions memos agenda psion3a et + > texte brut\nAttention ! Plante sur certains types d'entre rpte.\nDans ce cas, faire un kill de agn2tsv",NULL);
  gtk_tooltips_set_tip (gtooltip, button_format,
			_
			("For the Psion3a and more and Siena memos schedule conversions > ASCII text\nCareful ! Crashes on some repeated entries.\nIn this case, kill agn2tsv"),
			NULL);
  groupe_format = gtk_radio_button_group (GTK_RADIO_BUTTON (button_format));
  button_format =
    gtk_radio_button_new_with_label (groupe_format, "dbf > tsv (S3)");
  gtk_table_attach_defaults (GTK_TABLE (table), button_format, 0, 1, 15, 16);
  gtk_widget_show (button_format);
  gtk_signal_connect (GTK_OBJECT (button_format), "toggled",
		      GTK_SIGNAL_FUNC (rappel_bouton_format), "dbf2tsv");
//gtk_tooltips_set_tip (gtooltip, button_format, "Pour les conversions bases psion3 > texte  sparateurs",NULL);
  gtk_tooltips_set_tip (gtooltip, button_format,
			_
			("For the Psion3 and upper and Siena databases conversions > text"),
			NULL);

  groupe_format = gtk_radio_button_group (GTK_RADIO_BUTTON (button_format));
  button_format =
    gtk_radio_button_new_with_label (groupe_format, "spr > tsv (S3)");
  gtk_table_attach_defaults (GTK_TABLE (table), button_format, 0, 1, 16, 17);
  gtk_widget_show (button_format);
  gtk_signal_connect (GTK_OBJECT (button_format), "toggled",
		      GTK_SIGNAL_FUNC (rappel_bouton_format), "spr2tsv");
//gtk_tooltips_set_tip (gtooltip, button_format, "Pour les conversions tableurs psion3a et + > texte  sparateurs",NULL);
  gtk_tooltips_set_tip (gtooltip, button_format,
			_
			("For the Psion3a and more and Siena spreadsheets conversions > text TSV"),
			NULL);
  groupe_format = gtk_radio_button_group (GTK_RADIO_BUTTON (button_format));
  button_format =
    gtk_radio_button_new_with_label (groupe_format, "spr > html (S3)");
  gtk_table_attach_defaults (GTK_TABLE (table), button_format, 0, 1, 17, 18);
  gtk_widget_show (button_format);
  gtk_signal_connect (GTK_OBJECT (button_format), "toggled",
		      GTK_SIGNAL_FUNC (rappel_bouton_format), "spr2tsv -h");
//gtk_tooltips_set_tip (gtooltip, button_format, "Pour les conversions tableurs psion3a et + > html\nLe fichier obtenu n'a pas d'en-tte. Insrez le dans un document HTML ou rajoutez lui des en-ttes manuellement",NULL);
  gtk_tooltips_set_tip (gtooltip, button_format,
			_
			("For the Psion3a and more and Siena spreadsheets conversions > html\nThe html file has no header. You must insert it into a html file or add the header manually"),
			NULL);

  groupe_format = gtk_radio_button_group (GTK_RADIO_BUTTON (button_format));
  button_format =
    gtk_radio_button_new_with_label (groupe_format, "tsv > dbf (S3)");
  gtk_table_attach_defaults (GTK_TABLE (table), button_format, 1, 2, 12, 13);
  gtk_widget_show (button_format);
  gtk_signal_connect (GTK_OBJECT (button_format), "toggled",
		      GTK_SIGNAL_FUNC (rappel_bouton_format), "tsv2dbf");
//gtk_tooltips_set_tip (gtooltip, button_format, "Pour les conversions de texte  sparateurs > bases psion3\nSparateurs Tab Tab Return",NULL);
  gtk_tooltips_set_tip (gtooltip, button_format,
			_
			("For TSV text conversions > psion3 databases\n(Format Tab Tab Return)"),
			NULL);

  groupe_format = gtk_radio_button_group (GTK_RADIO_BUTTON (button_format));
  button_format =
    gtk_radio_button_new_with_label (groupe_format, "tsv > spr (S3)");
  gtk_table_attach_defaults (GTK_TABLE (table), button_format, 1, 2, 13, 14);
  gtk_widget_show (button_format);
  gtk_signal_connect (GTK_OBJECT (button_format), "toggled",
		      GTK_SIGNAL_FUNC (rappel_bouton_format), "tsv2spr");
//gtk_tooltips_set_tip (gtooltip, button_format, "Pour les conversions de texte  sparateurs > tableur psion3\nFormat Tab Tab Return",NULL);
  gtk_tooltips_set_tip (gtooltip, button_format,
			_
			("For TSV text conversions > Psion3 spreadsheets\n(Format Tab Tab Return)"),
			NULL);

//wve button
  groupe_format = gtk_radio_button_group (GTK_RADIO_BUTTON (button_format));
  button_format =
    gtk_radio_button_new_with_label (groupe_format, "wve > wav (S3)");
  gtk_table_attach_defaults (GTK_TABLE (table), button_format, 1, 2, 14, 15);
  gtk_widget_show (button_format);
  gtk_signal_connect (GTK_OBJECT (button_format), "toggled",
		      GTK_SIGNAL_FUNC (rappel_bouton_format), "sox");
//gtk_tooltips_set_tip (gtooltip, button_format, "Pour les conversions de sons S3 > sons .wav",NULL);
  gtk_tooltips_set_tip (gtooltip, button_format,
			_("For S3 sound conversions > .wav"), NULL);

//pic2ps button
  groupe_format = gtk_radio_button_group (GTK_RADIO_BUTTON (button_format));
  button_format =
    gtk_radio_button_new_with_label (groupe_format, "pic > ps (S3)");
  gtk_table_attach_defaults (GTK_TABLE (table), button_format, 1, 2, 11, 12);
  gtk_widget_show (button_format);
  gtk_signal_connect (GTK_OBJECT (button_format), "toggled",
		      GTK_SIGNAL_FUNC (rappel_bouton_format), "lpic2ps");
//gtk_tooltips_set_tip (gtooltip, button_format, "Pour les conversions de diagrammes du tableur > Postscript",NULL);
  gtk_tooltips_set_tip (gtooltip, button_format,
			_
			("For the Psion3a and more and Siena spreadsheets diagrams conversions > Postscript"),
			NULL);

//nconvert button
  groupe_format = gtk_radio_button_group (GTK_RADIO_BUTTON (button_format));
  button_format =
    gtk_radio_button_new_with_label (groupe_format, "pic > bmp (S3)");
  gtk_table_attach_defaults (GTK_TABLE (table), button_format, 1, 2, 15, 16);
  gtk_widget_show (button_format);
  gtk_signal_connect (GTK_OBJECT (button_format), "toggled",
		      GTK_SIGNAL_FUNC (rappel_bouton_format), "nconvert");

  gtk_tooltips_set_tip (gtooltip, button_format,
			_
			("For S3 pictures and icons conversions > .bmp\nNeeds /usr/X11R6/binnconvert"),
			NULL);

//psiconv button
  groupe_format = gtk_radio_button_group (GTK_RADIO_BUTTON (button_format));
  button_format =
    gtk_radio_button_new_with_label (groupe_format, "Psiconv (S5)");
  gtk_table_attach_defaults (GTK_TABLE (table), button_format, 1, 2, 16, 17);
  gtk_widget_show (button_format);
  gtk_signal_connect (GTK_OBJECT (button_format), "toggled",
		      GTK_SIGNAL_FUNC (rappel_bouton_format), "Psiconv");
//gtk_tooltips_set_tip (gtooltip, button_format, "Pour les conversions texte psion5 > html 3\nEncore beaucoup d'checs",NULL);
  gtk_tooltips_set_tip (gtooltip, button_format,
			_
			("For Psion5 text conversions > html 3\nThe tested version fails very often"),
			NULL);

//label_transfert = gtk_label_new("Transferts");
  label_transfert = gtk_label_new (_("Transfers"));
  gtk_table_attach_defaults (GTK_TABLE (table), label_transfert, 2, 3, 9, 10);
  gtk_widget_show (label_transfert);

//button_source = gtk_button_new_with_label ("Source");
  button_source = gtk_button_new_with_label (_("Source"));
  gtk_signal_connect (GTK_OBJECT (button_source), "clicked",
		      GTK_SIGNAL_FUNC (selec_source),
		      (gpointer) "Rpertoire");
  gtk_table_attach_defaults (GTK_TABLE (table), button_source, 2, 3, 10, 11);
  gtk_widget_show (button_source);
//gtk_tooltips_set_tip (gtooltip, button_source, "Pour slectionner le fichier source pour un transfert ou une conversion",NULL);
  gtk_tooltips_set_tip (gtooltip, button_source,
			_
			("To select the source file for a transfer or a conversion"),
			NULL);

//button_cible = gtk_button_new_with_label ("Cible");
  button_cible = gtk_button_new_with_label (_("Target"));
  gtk_signal_connect (GTK_OBJECT (button_cible), "clicked",
		      GTK_SIGNAL_FUNC (selec_cible), (gpointer) "Rpertoire");
  gtk_table_attach_defaults (GTK_TABLE (table), button_cible, 2, 3, 11, 12);
  gtk_widget_show (button_cible);
//gtk_tooltips_set_tip (gtooltip, button_cible, "Pour slectionner le fichier cible pour un transfert, une conversion ou une sauvegarde",NULL);
  gtk_tooltips_set_tip (gtooltip, button_cible,
			_
			("To select the target file for a transfer, conversion or a backup (S3)"),
			NULL);

//button_copier = gtk_button_new_with_label ("Copier");
  button_copier = gtk_button_new_with_label (_("Copy"));
  gtk_signal_connect (GTK_OBJECT (button_copier), "clicked",
		      GTK_SIGNAL_FUNC (transferts), (gpointer) NULL);
  gtk_table_attach_defaults (GTK_TABLE (table), button_copier, 1, 2, 17, 18);
  gtk_widget_show (button_copier);
//gtk_tooltips_set_tip (gtooltip, button_copier, "Pour effectuer la copie, aprs avoir choisi les formats et les fichiers avec les boutons ci-dessus\nPour la copie sans conversion, vous pouvez galement utiliser n'importe quel gestionnaire de fichiers de Linux",NULL);
  gtk_tooltips_set_tip (gtooltip, button_copier,
			_
			("To copy, after having choosen the file, the format and the target\nTo copy without converting, you can use as well any Linux File Manager"),
			NULL);

  button_disque = gtk_radio_button_new_with_label (NULL, "A");
  gtk_table_attach_defaults (GTK_TABLE (table), button_disque, 2, 3, 12, 13);
  gtk_widget_show (button_disque);
  gtk_signal_connect (GTK_OBJECT (button_disque), "toggled",
		      GTK_SIGNAL_FUNC (rappel_bouton_disque), "a");
//gtk_tooltips_set_tip (gtooltip, button_disque, "Pour sauvegarder le disque A du Psion",NULL);
  gtk_tooltips_set_tip (gtooltip, button_disque,
			_
			("To backup the Psion 3 A disk into the selected target directory"),
			NULL);

  groupe_disque = gtk_radio_button_group (GTK_RADIO_BUTTON (button_disque));
//button_disque = gtk_radio_button_new_with_label(groupe_disque, "Interne");
  button_disque =
    gtk_radio_button_new_with_label (groupe_disque, _("Middle"));
  gtk_table_attach_defaults (GTK_TABLE (table), button_disque, 2, 3, 13, 14);
  gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (button_disque), TRUE);
  gtk_widget_show (button_disque);
  gtk_signal_connect (GTK_OBJECT (button_disque), "toggled",
		      GTK_SIGNAL_FUNC (rappel_bouton_disque), "i");
//gtk_tooltips_set_tip (gtooltip, button_disque, "Pour sauvegarder le disque interne M du Psion",NULL);
  gtk_tooltips_set_tip (gtooltip, button_disque,
			_
			("To backup the Psion 3 or Siena internal disk into the selected target directory"),
			NULL);

  groupe_disque = gtk_radio_button_group (GTK_RADIO_BUTTON (button_disque));
  button_disque = gtk_radio_button_new_with_label (groupe_disque, "B");
  gtk_table_attach_defaults (GTK_TABLE (table), button_disque, 2, 3, 14, 15);
  gtk_widget_show (button_disque);
  gtk_signal_connect (GTK_OBJECT (button_disque), "toggled",
		      GTK_SIGNAL_FUNC (rappel_bouton_disque), "b");
//gtk_tooltips_set_tip (gtooltip, button_disque, "Pour sauvegarder le disque B du Psion",NULL);
  gtk_tooltips_set_tip (gtooltip, button_disque,
			_
			("To backup the Psion 3 B disk into the selected target directory"),
			NULL);

  groupe_disque = gtk_radio_button_group (GTK_RADIO_BUTTON (button_disque));
  button_disque = gtk_radio_button_new_with_label (groupe_disque, "ROM");
  gtk_table_attach_defaults (GTK_TABLE (table), button_disque, 2, 3, 15, 16);
  gtk_widget_show (button_disque);
  gtk_signal_connect (GTK_OBJECT (button_disque), "toggled",
		      GTK_SIGNAL_FUNC (rappel_bouton_disque), "r");
//gtk_tooltips_set_tip (gtooltip, button_disque, "Pour copier la ROM du Psion",NULL);
  gtk_tooltips_set_tip (gtooltip, button_disque,
			_
			("To copy the Psion 3 or Siena ROM into the selected target directory"),
			NULL);

//button_sauvegarde = gtk_button_new_with_label ("Sauvegarde S3");
  button_sauvegarde = gtk_button_new_with_label (_("S3 Siena Backup"));
  gtk_signal_connect (GTK_OBJECT (button_sauvegarde), "clicked",
		      GTK_SIGNAL_FUNC (backup), (gpointer) NULL);
  gtk_table_attach_defaults (GTK_TABLE (table), button_sauvegarde, 2, 3, 17,
			     18);
  gtk_widget_show (button_sauvegarde);
/*  gtk_tooltips_set_tip (gtooltip, button_sauvegarde,
			"Pour sauvegarder le Psion S3\nCopie tout dans un rpertoire\nPensez  tablir la connexion auparavant\nNe changez pas le rpertoire de mountage\nSlectionnez le rpertoire cible (qui doit exister) avec le bouton cible\n Choisissez le disque  sauvegarder avec les boutons ci-dessus",
			NULL); */
  gtk_tooltips_set_tip (gtooltip, button_sauvegarde,
			_
			("To backup the Psion S3 or Siena\nCopies the whole Psion disk into the selected target directory\nThe next backup will only copy the new and modified files\nDo not change the mounting directory !\nThe target directory must exist\n Choose the disk to be backuped with the buttons above"),
			NULL);

//button_quitte = gtk_button_new_with_label ("Quitter");
  button_quitte = gtk_button_new_with_label (_("Quit"));
  gtk_signal_connect (GTK_OBJECT (button_quitte), "clicked",
		      GTK_SIGNAL_FUNC (delete_event), NULL);
  gtk_table_attach_defaults (GTK_TABLE (table), button_quitte, 0, 3, 18, 19);
  gtk_widget_show (button_quitte);
//gtk_tooltips_set_tip (gtooltip, button_quitte, "Ce bouton l, on se demande bien  quoi il peut servir ;-))",NULL);
  gtk_tooltips_set_tip (gtooltip, button_quitte,
			_("What on earth could this button be for ? ;-))"),
			NULL);
  gtk_widget_show (table);
  gtk_widget_show (window);

  gtk_main ();

  return FALSE;
}
